/*********************************************************************
*                                                                    *
*                SEGGER Microcontroller GmbH & Co. KG                *
*        Solutions for real time microcontroller applications        *
*                                                                    *
**********************************************************************
*                                                                    *
* C-file generated by:                                               *
*                                                                    *
*        GUI_Builder for emWin version 5.32                          *
*        Compiled Oct  8 2015, 11:59:02                              *
*        (c) 2015 Segger Microcontroller GmbH & Co. KG               *
*                                                                    *
**********************************************************************
*                                                                    *
*        Internet: www.segger.com  Support: support@segger.com       *
*                                                                    *
**********************************************************************
*/

// USER START (Optionally insert additional includes)
#include "stm32f7xx_hal.h"
#include "math.h"
#include "lsm6ds0.h"
// USER END

#include "DIALOG.h"

/*********************************************************************
*
*       Defines
*
**********************************************************************
*/
#define ID_WINDOW_0     (GUI_ID_USER + 0x00)
#define ID_BUTTON_0     (GUI_ID_USER + 0x01)
#define ID_TEXT_0     (GUI_ID_USER + 0x02)
#define ID_TEXT_1     (GUI_ID_USER + 0x03)
#define ID_TEXT_2     (GUI_ID_USER + 0x04)
#define ID_GRAPH_0     (GUI_ID_USER + 0x05)


// USER START (Optionally insert additional defines)
// USER END

/*********************************************************************
*
*       Static data
*
**********************************************************************
*/

// USER START (Optionally insert additional static data)
extern int16_t xval, yval, zval;
WM_HTIMER hTimer1;
char str01[10]={0};
static int data_v;
GRAPH_DATA_Handle hData1,hData2,hData3;
GRAPH_SCALE_Handle hScale;
static U8 graph_stat=0;
// USER END

/*********************************************************************
*
*       _aDialogCreate
*/
static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { WINDOW_CreateIndirect, "Window", ID_WINDOW_0, 0, 0, 515, 280, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "Button", ID_BUTTON_0, 380, 234, 80, 20, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_0, 15, 234, 82, 22, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_1, 110, 234, 82, 20, 0, 0x0, 0 },
  { TEXT_CreateIndirect, "Text", ID_TEXT_2, 205, 234, 82, 20, 0, 0x0, 0 },
  { GRAPH_CreateIndirect, "Graph", ID_GRAPH_0, 11, 12, 446, 206, 0, 0x0, 0 },
  // USER START (Optionally insert additional widgets)
  // USER END
};

/*********************************************************************
*
*       Static code
*
**********************************************************************
*/

// USER START (Optionally insert additional static code)
// USER END

/*********************************************************************
*
*       _cbDialog
*/
static void _cbDialog(WM_MESSAGE * pMsg) {
  WM_HWIN hItem;
  int     NCode;
  int     Id;
  // USER START (Optionally insert additional variables)
  // USER END

  switch (pMsg->MsgId) {
  case WM_INIT_DIALOG:
    //
    // Initialization of 'Window'
    //
    hItem = pMsg->hWin;
    WINDOW_SetBkColor(hItem, GUI_MAKE_COLOR(0x00C0C0C0));
    //
    // Initialization of 'Button'
    //
    hItem = WM_GetDialogItem(pMsg->hWin, ID_BUTTON_0);
    BUTTON_SetFont(hItem, GUI_FONT_16B_1);
    BUTTON_SetText(hItem, "Stop");
    //
    // Initialization of 'Graph'
    //
    hItem = WM_GetDialogItem(pMsg->hWin, ID_GRAPH_0);
    GRAPH_SetBorder(hItem, 2, 2, 2, 2);
    //
	// Initialization of 'Text'
	//
	hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_0);
	TEXT_SetTextColor(hItem, GUI_MAKE_COLOR(0x00008000));
	TEXT_SetFont(hItem, GUI_FONT_16B_1);
	//
	// Initialization of 'Text'
	//
	hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_1);
	TEXT_SetFont(hItem, GUI_FONT_16B_1);
	TEXT_SetTextColor(hItem, GUI_MAKE_COLOR(0x00008000));
	//
	// Initialization of 'Text'
	//
	hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_2);
	TEXT_SetFont(hItem, GUI_FONT_16B_1);
	TEXT_SetTextColor(hItem, GUI_MAKE_COLOR(0x00008000));
    // USER START (Optionally insert additional code for further widget initialization)
	hItem = WM_GetDialogItem(pMsg->hWin, ID_GRAPH_0);
	GRAPH_SetColor(hItem,GUI_LIGHTBLUE,GRAPH_CI_BK);
	GRAPH_SetColor(hItem,GUI_GREEN,GRAPH_CI_FRAME);
	GRAPH_SetColor(hItem,GUI_LIGHTMAGENTA,GRAPH_CI_GRID);
	GRAPH_SetLineStyleH(hItem,GUI_LS_DASH);
	GRAPH_SetLineStyleV(hItem,GUI_LS_DASH);
	GRAPH_SetGridVis(hItem,1);
	GRAPH_SetGridDistY(hItem,25);
	hData1 = GRAPH_DATA_YT_Create(GUI_YELLOW, 400, 0, 1);
	hData2 = GRAPH_DATA_YT_Create(GUI_RED, 400, 0, 1);
	hData3 = GRAPH_DATA_YT_Create(GUI_GREEN, 400, 0, 1);
	GRAPH_AttachData(hItem, hData1);
	GRAPH_AttachData(hItem, hData2);
	GRAPH_AttachData(hItem, hData3);
	GRAPH_DATA_XY_SetOffY(hData1,100);
	GRAPH_DATA_XY_SetOffY(hData2,100);
	GRAPH_DATA_XY_SetOffY(hData3,100);
	hScale = GRAPH_SCALE_Create(25, GUI_TA_RIGHT, GRAPH_SCALE_CF_VERTICAL, 25);
	GRAPH_AttachScale(hItem, hScale);
	GRAPH_SCALE_SetOff(hScale,100);
	GRAPH_SCALE_SetTextColor(hScale,GUI_BLACK);

	hTimer1 = WM_CreateTimer(pMsg->hWin, 0, 100, 0);
    // USER END
    break;
  case WM_TIMER:
    Accel_ReadAcc();
    GRAPH_DATA_YT_AddValue(hData1, xval/170);
    GRAPH_DATA_YT_AddValue(hData2, yval/170);
    GRAPH_DATA_YT_AddValue(hData3, zval/170);
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_0);
    sprintf(str01,"X: %05d", xval);
    TEXT_SetText(hItem, str01);
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_1);
    sprintf(str01,"Y: %05d", yval);
    TEXT_SetText(hItem, str01);
    hItem = WM_GetDialogItem(pMsg->hWin, ID_TEXT_2);
    sprintf(str01,"Z: %05d", zval);
    TEXT_SetText(hItem, str01);
    GUI_Exec();
    data_v = pMsg->Data.v;
    if(graph_stat==0) WM_RestartTimer(data_v, 10);
    break;
  case WM_NOTIFY_PARENT:
    Id    = WM_GetId(pMsg->hWinSrc);
    NCode = pMsg->Data.v;
    switch(Id) {
    case ID_BUTTON_0: // Notifications sent by 'Button'
      switch(NCode) {
      case WM_NOTIFICATION_CLICKED:
        // USER START (Optionally insert code for reacting on notification message)
        // USER END
        break;
      case WM_NOTIFICATION_RELEASED:
        // USER START (Optionally insert code for reacting on notification message)
    	  hItem = WM_GetDialogItem(pMsg->hWin, ID_BUTTON_0);
    	  if(graph_stat==0)
    	  {
    	    graph_stat=1;
    	    BUTTON_SetText(hItem, "Start");
    	  }
    	  else
    	  {
    	    graph_stat=0;
    	    BUTTON_SetText(hItem, "Stop");
    	    WM_RestartTimer(data_v, 10);
    	  }
        // USER END
        break;
      // USER START (Optionally insert additional code for further notification handling)
      // USER END
      }
      break;
    // USER START (Optionally insert additional code for further Ids)
    // USER END
    }
    break;
  // USER START (Optionally insert additional message handling)
  // USER END
  default:
    WM_DefaultProc(pMsg);
    break;
  }
}

/*********************************************************************
*
*       Public code
*
**********************************************************************
*/
/*********************************************************************
*
*       CreateWindow
*/
WM_HWIN CreateWindow(void);
WM_HWIN CreateWindow(void) {
  WM_HWIN hWin;

  hWin = GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), _cbDialog, WM_HBKWIN, 0, 0);
  return hWin;
}

// USER START (Optionally insert additional public code)
// USER END

/*************************** End of file ****************************/
